    .set    noreorder
    .set    mips32
    .set    noat
    .text

_start: .global _start

    #
    # DDR 64 MiB at 0x80000000
    #
    # We set DDR_PLL, and gate for it
    # then we configure it with DDR_CSR reg

    li $5, 0xb82f4004
    li $6, 0xffffffff # CLK_EN. enable all clocks
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f4000
    li $6, 0x9e000094 # CR_PLL. xti = 10 MHz, ddr 150MHz, nand off, ,cpu 100MHz
    nop
    sw $6, 0x0 ($5)

    #---------------------------------
    # DDR SDRAM memory setup on MCT-04-EM
    # Phys addresses 0000_0000 : 03FF_FFFF

    # DDR_CON
    li $5, 0xb82f1014
    li $6, 0x00fa1020 #conf80
    nop
    sw $6, 0x0 ($5)

    # DDR_TMR
    li $5, 0xb82f1018
    li $6, 0x05740111 #tmr80
    nop
    sw $6, 0x0 ($5)

    # DDR_MOD
    li $5, 0xb82f1020
    li $6, 0x00000000 #mod
    nop
    sw $6, 0x0 ($5)

    # DDR_CSR
    li $5, 0xb82f101c
    li $6, 0x40
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x1
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x20
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x20
    nop
    sw $6, 0x0 ($5)

    # DDR_MOD
    li $5, 0xb82f1020
    li $6, 0x800f #mod
    nop
    sw $6, 0x0 ($5)

    # DDR_CSR
    li $5, 0xb82f101c
    li $6, 0x40
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x1
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x20
    nop
    sw $6, 0x0 ($5)

    li $5, 0xb82f101c
    li $6, 0x20
    nop
    sw $6, 0x0 ($5)
    #---------------------------------

    la      $4, _spi_boot_2_start
    jr      $4
    nop
